package com.sun.nio.sctp;

import sun.nio.ch.sctp.MessageInfoImpl;
import java.net.SocketAddress;
import jdk.Exported;

@Exported
public abstract class MessageInfo
{
    protected MessageInfo() {
    }
    
    public static MessageInfo createOutgoing(SocketAddress address, int streamNumber) {
        if (streamNumber < 0 || streamNumber > 65536) {
            throw new IllegalArgumentException("Invalid stream number");
        }
        return new MessageInfoImpl(null, address, streamNumber);
    }
    
    public static MessageInfo createOutgoing(Association association, SocketAddress address, int streamNumber) {
        if (association == null) {
            throw new IllegalArgumentException("association cannot be null");
        }
        if (streamNumber < 0 || streamNumber > 65536) {
            throw new IllegalArgumentException("Invalid stream number");
        }
        return new MessageInfoImpl(association, address, streamNumber);
    }
    
    public abstract SocketAddress address();
    
    public abstract Association association();
    
    public abstract int bytes();
    
    public abstract boolean isComplete();
    
    public abstract MessageInfo complete(boolean p0);
    
    public abstract boolean isUnordered();
    
    public abstract MessageInfo unordered(boolean p0);
    
    public abstract int payloadProtocolID();
    
    public abstract MessageInfo payloadProtocolID(int p0);
    
    public abstract int streamNumber();
    
    public abstract MessageInfo streamNumber(int p0);
    
    public abstract long timeToLive();
    
    public abstract MessageInfo timeToLive(long p0);
}
